package cn.superdesk.uniorder.dao.entity.marketing.department;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class UnifiedAreaCityExample {
    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    protected String orderByClause;

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    protected boolean distinct;

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public UnifiedAreaCityExample() {
        oredCriteria = new ArrayList<>();
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andParentIdIsNull() {
            addCriterion("parent_id is null");
            return (Criteria) this;
        }

        public Criteria andParentIdIsNotNull() {
            addCriterion("parent_id is not null");
            return (Criteria) this;
        }

        public Criteria andParentIdEqualTo(Long value) {
            addCriterion("parent_id =", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdNotEqualTo(Long value) {
            addCriterion("parent_id <>", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdGreaterThan(Long value) {
            addCriterion("parent_id >", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("parent_id >=", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdLessThan(Long value) {
            addCriterion("parent_id <", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdLessThanOrEqualTo(Long value) {
            addCriterion("parent_id <=", value, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdIn(List<Long> values) {
            addCriterion("parent_id in", values, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdNotIn(List<Long> values) {
            addCriterion("parent_id not in", values, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdBetween(Long value1, Long value2) {
            addCriterion("parent_id between", value1, value2, "parentId");
            return (Criteria) this;
        }

        public Criteria andParentIdNotBetween(Long value1, Long value2) {
            addCriterion("parent_id not between", value1, value2, "parentId");
            return (Criteria) this;
        }

        public Criteria andLevIsNull() {
            addCriterion("lev is null");
            return (Criteria) this;
        }

        public Criteria andLevIsNotNull() {
            addCriterion("lev is not null");
            return (Criteria) this;
        }

        public Criteria andLevEqualTo(Integer value) {
            addCriterion("lev =", value, "lev");
            return (Criteria) this;
        }

        public Criteria andLevNotEqualTo(Integer value) {
            addCriterion("lev <>", value, "lev");
            return (Criteria) this;
        }

        public Criteria andLevGreaterThan(Integer value) {
            addCriterion("lev >", value, "lev");
            return (Criteria) this;
        }

        public Criteria andLevGreaterThanOrEqualTo(Integer value) {
            addCriterion("lev >=", value, "lev");
            return (Criteria) this;
        }

        public Criteria andLevLessThan(Integer value) {
            addCriterion("lev <", value, "lev");
            return (Criteria) this;
        }

        public Criteria andLevLessThanOrEqualTo(Integer value) {
            addCriterion("lev <=", value, "lev");
            return (Criteria) this;
        }

        public Criteria andLevIn(List<Integer> values) {
            addCriterion("lev in", values, "lev");
            return (Criteria) this;
        }

        public Criteria andLevNotIn(List<Integer> values) {
            addCriterion("lev not in", values, "lev");
            return (Criteria) this;
        }

        public Criteria andLevBetween(Integer value1, Integer value2) {
            addCriterion("lev between", value1, value2, "lev");
            return (Criteria) this;
        }

        public Criteria andLevNotBetween(Integer value1, Integer value2) {
            addCriterion("lev not between", value1, value2, "lev");
            return (Criteria) this;
        }

        public Criteria andAreaNameIsNull() {
            addCriterion("area_name is null");
            return (Criteria) this;
        }

        public Criteria andAreaNameIsNotNull() {
            addCriterion("area_name is not null");
            return (Criteria) this;
        }

        public Criteria andAreaNameEqualTo(String value) {
            addCriterion("area_name =", value, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameNotEqualTo(String value) {
            addCriterion("area_name <>", value, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameGreaterThan(String value) {
            addCriterion("area_name >", value, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameGreaterThanOrEqualTo(String value) {
            addCriterion("area_name >=", value, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameLessThan(String value) {
            addCriterion("area_name <", value, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameLessThanOrEqualTo(String value) {
            addCriterion("area_name <=", value, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameLike(String value) {
            addCriterion("area_name like", value, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameNotLike(String value) {
            addCriterion("area_name not like", value, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameIn(List<String> values) {
            addCriterion("area_name in", values, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameNotIn(List<String> values) {
            addCriterion("area_name not in", values, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameBetween(String value1, String value2) {
            addCriterion("area_name between", value1, value2, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaNameNotBetween(String value1, String value2) {
            addCriterion("area_name not between", value1, value2, "areaName");
            return (Criteria) this;
        }

        public Criteria andAreaCodeIsNull() {
            addCriterion("area_code is null");
            return (Criteria) this;
        }

        public Criteria andAreaCodeIsNotNull() {
            addCriterion("area_code is not null");
            return (Criteria) this;
        }

        public Criteria andAreaCodeEqualTo(String value) {
            addCriterion("area_code =", value, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeNotEqualTo(String value) {
            addCriterion("area_code <>", value, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeGreaterThan(String value) {
            addCriterion("area_code >", value, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeGreaterThanOrEqualTo(String value) {
            addCriterion("area_code >=", value, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeLessThan(String value) {
            addCriterion("area_code <", value, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeLessThanOrEqualTo(String value) {
            addCriterion("area_code <=", value, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeLike(String value) {
            addCriterion("area_code like", value, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeNotLike(String value) {
            addCriterion("area_code not like", value, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeIn(List<String> values) {
            addCriterion("area_code in", values, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeNotIn(List<String> values) {
            addCriterion("area_code not in", values, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeBetween(String value1, String value2) {
            addCriterion("area_code between", value1, value2, "areaCode");
            return (Criteria) this;
        }

        public Criteria andAreaCodeNotBetween(String value1, String value2) {
            addCriterion("area_code not between", value1, value2, "areaCode");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersIsNull() {
            addCriterion("customer_users is null");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersIsNotNull() {
            addCriterion("customer_users is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersEqualTo(String value) {
            addCriterion("customer_users =", value, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersNotEqualTo(String value) {
            addCriterion("customer_users <>", value, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersGreaterThan(String value) {
            addCriterion("customer_users >", value, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersGreaterThanOrEqualTo(String value) {
            addCriterion("customer_users >=", value, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersLessThan(String value) {
            addCriterion("customer_users <", value, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersLessThanOrEqualTo(String value) {
            addCriterion("customer_users <=", value, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersLike(String value) {
            addCriterion("customer_users like", value, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersNotLike(String value) {
            addCriterion("customer_users not like", value, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersIn(List<String> values) {
            addCriterion("customer_users in", values, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersNotIn(List<String> values) {
            addCriterion("customer_users not in", values, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersBetween(String value1, String value2) {
            addCriterion("customer_users between", value1, value2, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andCustomerUsersNotBetween(String value1, String value2) {
            addCriterion("customer_users not between", value1, value2, "customerUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersIsNull() {
            addCriterion("purchase_users is null");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersIsNotNull() {
            addCriterion("purchase_users is not null");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersEqualTo(String value) {
            addCriterion("purchase_users =", value, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersNotEqualTo(String value) {
            addCriterion("purchase_users <>", value, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersGreaterThan(String value) {
            addCriterion("purchase_users >", value, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersGreaterThanOrEqualTo(String value) {
            addCriterion("purchase_users >=", value, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersLessThan(String value) {
            addCriterion("purchase_users <", value, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersLessThanOrEqualTo(String value) {
            addCriterion("purchase_users <=", value, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersLike(String value) {
            addCriterion("purchase_users like", value, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersNotLike(String value) {
            addCriterion("purchase_users not like", value, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersIn(List<String> values) {
            addCriterion("purchase_users in", values, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersNotIn(List<String> values) {
            addCriterion("purchase_users not in", values, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersBetween(String value1, String value2) {
            addCriterion("purchase_users between", value1, value2, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andPurchaseUsersNotBetween(String value1, String value2) {
            addCriterion("purchase_users not between", value1, value2, "purchaseUsers");
            return (Criteria) this;
        }

        public Criteria andRemarksIsNull() {
            addCriterion("remarks is null");
            return (Criteria) this;
        }

        public Criteria andRemarksIsNotNull() {
            addCriterion("remarks is not null");
            return (Criteria) this;
        }

        public Criteria andRemarksEqualTo(String value) {
            addCriterion("remarks =", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksNotEqualTo(String value) {
            addCriterion("remarks <>", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksGreaterThan(String value) {
            addCriterion("remarks >", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksGreaterThanOrEqualTo(String value) {
            addCriterion("remarks >=", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksLessThan(String value) {
            addCriterion("remarks <", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksLessThanOrEqualTo(String value) {
            addCriterion("remarks <=", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksLike(String value) {
            addCriterion("remarks like", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksNotLike(String value) {
            addCriterion("remarks not like", value, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksIn(List<String> values) {
            addCriterion("remarks in", values, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksNotIn(List<String> values) {
            addCriterion("remarks not in", values, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksBetween(String value1, String value2) {
            addCriterion("remarks between", value1, value2, "remarks");
            return (Criteria) this;
        }

        public Criteria andRemarksNotBetween(String value1, String value2) {
            addCriterion("remarks not between", value1, value2, "remarks");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNull() {
            addCriterion("update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNotNull() {
            addCriterion("update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdEqualTo(Long value) {
            addCriterion("update_user_id =", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotEqualTo(Long value) {
            addCriterion("update_user_id <>", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThan(Long value) {
            addCriterion("update_user_id >", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("update_user_id >=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThan(Long value) {
            addCriterion("update_user_id <", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("update_user_id <=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIn(List<Long> values) {
            addCriterion("update_user_id in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotIn(List<Long> values) {
            addCriterion("update_user_id not in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("update_user_id between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("update_user_id not between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesIsNull() {
            addCriterion("area_full_names is null");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesIsNotNull() {
            addCriterion("area_full_names is not null");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesEqualTo(String value) {
            addCriterion("area_full_names =", value, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesNotEqualTo(String value) {
            addCriterion("area_full_names <>", value, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesGreaterThan(String value) {
            addCriterion("area_full_names >", value, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesGreaterThanOrEqualTo(String value) {
            addCriterion("area_full_names >=", value, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesLessThan(String value) {
            addCriterion("area_full_names <", value, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesLessThanOrEqualTo(String value) {
            addCriterion("area_full_names <=", value, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesLike(String value) {
            addCriterion("area_full_names like", value, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesNotLike(String value) {
            addCriterion("area_full_names not like", value, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesIn(List<String> values) {
            addCriterion("area_full_names in", values, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesNotIn(List<String> values) {
            addCriterion("area_full_names not in", values, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesBetween(String value1, String value2) {
            addCriterion("area_full_names between", value1, value2, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullNamesNotBetween(String value1, String value2) {
            addCriterion("area_full_names not between", value1, value2, "areaFullNames");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsIsNull() {
            addCriterion("area_full_ids is null");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsIsNotNull() {
            addCriterion("area_full_ids is not null");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsEqualTo(String value) {
            addCriterion("area_full_ids =", value, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsNotEqualTo(String value) {
            addCriterion("area_full_ids <>", value, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsGreaterThan(String value) {
            addCriterion("area_full_ids >", value, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsGreaterThanOrEqualTo(String value) {
            addCriterion("area_full_ids >=", value, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsLessThan(String value) {
            addCriterion("area_full_ids <", value, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsLessThanOrEqualTo(String value) {
            addCriterion("area_full_ids <=", value, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsLike(String value) {
            addCriterion("area_full_ids like", value, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsNotLike(String value) {
            addCriterion("area_full_ids not like", value, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsIn(List<String> values) {
            addCriterion("area_full_ids in", values, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsNotIn(List<String> values) {
            addCriterion("area_full_ids not in", values, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsBetween(String value1, String value2) {
            addCriterion("area_full_ids between", value1, value2, "areaFullIds");
            return (Criteria) this;
        }

        public Criteria andAreaFullIdsNotBetween(String value1, String value2) {
            addCriterion("area_full_ids not between", value1, value2, "areaFullIds");
            return (Criteria) this;
        }
    }

    /**
     *
     * table unified_area_city
     *
     * do_not_delete_during_merge Tue Nov 24 16:53:37 CST 2020
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    /**
     *
     * table unified_area_city
     *
     * Tue Nov 24 16:53:37 CST 2020
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}